OGRE: Ogre::Page Class Reference

| OGRE 2.2.4 Object-Oriented Graphics Rendering Engine

Classes | Public Types | Public Member Functions | Static Public Attributes | Friends | List of all members
Ogre::Page Class Reference
Components » Paging

Page class. More...

`#include <OgrePage.h>`

Inheritance diagram for Ogre::Page:
[legend]

## Public Types
typedef vector< PageContentCollection * >::type | ContentCollectionList

## Public Member Functions
| Page (PageID pageID, PagedWorldSection *parent)
virtual | ~Page ()
void | _notifyModified ()
| Tell the page that it is modified. More...
bool | canHandleRequest (const WorkQueue::Request *req, const WorkQueue *srcQ)
| WorkQueue::RequestHandler override. More...
bool | canHandleResponse (const WorkQueue::Response *res, const WorkQueue *srcQ)
| WorkQueue::ResponseHandler override. More...
virtual PageContentCollection * | createContentCollection (const String &typeName)
| Create a new PageContentCollection within this page. More...
virtual void | destroyAllContentCollections ()
| Destroy all PageContentCollections within this page. More...
virtual void | destroyContentCollection (PageContentCollection *coll)
| Destroy a PageContentCollection within this page. More...
virtual void | frameEnd (Real timeElapsed)
| Called when the frame ends. More...
virtual void | frameStart (Real timeSinceLastFrame)
| Called when the frame starts. More...
virtual PageContentCollection * | getContentCollection (size_t index)
| Get a content collection. More...
virtual size_t | getContentCollectionCount () const
| Get the number of content collections. More...
const ContentCollectionList & | getContentCollectionList () const
| Get the list of content collections. More...
virtual unsigned long | getFrameLastHeld ()
| Get the frame number in which this Page was last loaded or held. More...
virtual PageID | getID () const
| Get the ID of this page, unique within the parent. More...
PageManager * | getManager () const
virtual PagedWorldSection * | getParentSection () const
| Get the PagedWorldSection this page belongs to. More...
SceneManager * | getSceneManager () const
WorkQueue::Response * | handleRequest (const WorkQueue::Request *req, const WorkQueue *srcQ)
| WorkQueue::RequestHandler override. More...
void | handleResponse (const WorkQueue::Response *res, const WorkQueue *srcQ)
| WorkQueue::ResponseHandler override. More...
bool | isDeferredProcessInProgress () const
| If true, it's not safe to access this Page at this time, contents may be changing. More...
virtual bool | isHeld () const
| Returns whether this page was 'held' in the last frame, that is was it either directly needed, or requested to stay in memory (held - as in a buffer region for example). More...
bool | isModified () const
virtual void | load (bool synchronous)
| Load this page. More...
virtual void | notifyCamera (Camera *cam)
| Notify a section of the current camera. More...
void | operator delete (void *ptr)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete (void *ptr, void *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
void * | operator new (size_t sz)
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info More...
void * | operator new (size_t sz, void *ptr)
| placement operator new More...
void * | operator new[] (size_t sz)
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info More...
virtual void | save ()
| Save page data to an automatically generated file name. More...
virtual void | save (const String &filename)
| Save page data to a file. More...
virtual void | save (StreamSerialiser &stream)
| Save page data to a serialiser. More...
virtual void | touch ()
| 'Touch' the page to let it know it's being used More...
virtual void | unload ()
| Unload this page. More...

## Static Public Attributes
static const uint32 | CHUNK_CONTENTCOLLECTION_DECLARATION_ID
static const uint32 | CHUNK_ID
static const uint16 | CHUNK_VERSION
static const uint16 | WORKQUEUE_CHANGECOLLECTION_REQUEST
static const uint16 | WORKQUEUE_PREPARE_REQUEST

## Friends
_OgrePagingExport friend std::ostream & | operator<< (std::ostream &o, const Page &p)
| Function for writing to a stream. More...

## Detailed Description

Page class.

## Member Typedef Documentation

## ◆ ContentCollectionList

typedef vector<PageContentCollection*>::type Ogre::Page::ContentCollectionList

## Constructor & Destructor Documentation

## ◆ Page()

Ogre::Page::Page | ( | PageID | pageID,
|  | PagedWorldSection * | parent
| ) |  |

## ◆ ~Page()

virtual Ogre::Page::~Page | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ _notifyModified()

void Ogre::Page::_notifyModified | ( |  | ) |
| inline

Tell the page that it is modified.

## ◆ canHandleRequest()

bool Ogre::Page::canHandleRequest | ( | const WorkQueue::Request * | req,
|  | const WorkQueue * | srcQ
| ) |  |
| virtual

WorkQueue::RequestHandler override.

Reimplemented from Ogre::WorkQueue::RequestHandler.

## ◆ canHandleResponse()

bool Ogre::Page::canHandleResponse | ( | const WorkQueue::Response * | res,
|  | const WorkQueue * | srcQ
| ) |  |
| virtual

WorkQueue::ResponseHandler override.

Reimplemented from Ogre::WorkQueue::ResponseHandler.

## ◆ createContentCollection()

virtual PageContentCollection* Ogre::Page::createContentCollection | ( | const String & | typeName | ) |
| virtual

Create a new PageContentCollection within this page.

This is equivalent to calling PageManager::createContentCollection and then attachContentCollection.

Parameters

  typeName | The name of the type of content collection (see PageManager::getContentCollectionFactories)

## ◆ destroyAllContentCollections()

virtual void Ogre::Page::destroyAllContentCollections | ( |  | ) |
| virtual

Destroy all PageContentCollections within this page.

## ◆ destroyContentCollection()

virtual void Ogre::Page::destroyContentCollection | ( | PageContentCollection * | coll | ) |
| virtual

Destroy a PageContentCollection within this page.

This is equivalent to calling detachContentCollection and PageManager::destroyContentCollection.

## ◆ frameEnd()

virtual void Ogre::Page::frameEnd | ( | Real | timeElapsed | ) |
| virtual

Called when the frame ends.

## ◆ frameStart()

virtual void Ogre::Page::frameStart | ( | Real | timeSinceLastFrame | ) |
| virtual

Called when the frame starts.

## ◆ getContentCollection()

virtual PageContentCollection* Ogre::Page::getContentCollection | ( | size_t | index | ) |
| virtual

Get a content collection.

## ◆ getContentCollectionCount()

virtual size_t Ogre::Page::getContentCollectionCount | ( |  | ) | const
| virtual

Get the number of content collections.

## ◆ getContentCollectionList()

const ContentCollectionList& Ogre::Page::getContentCollectionList | ( |  | ) | const

Get the list of content collections.

## ◆ getFrameLastHeld()

virtual unsigned long Ogre::Page::getFrameLastHeld | ( |  | ) |
| inlinevirtual

Get the frame number in which this Page was last loaded or held.

Remarks
  A Page that has not been requested to be loaded or held in the recent past will be a candidate for removal.

## ◆ getID()

virtual PageID Ogre::Page::getID | ( |  | ) | const
| inlinevirtual

Get the ID of this page, unique within the parent.

## ◆ getManager()

PageManager* Ogre::Page::getManager | ( |  | ) | const

## ◆ getParentSection()

virtual PagedWorldSection* Ogre::Page::getParentSection | ( |  | ) | const
| inlinevirtual

Get the PagedWorldSection this page belongs to.

## ◆ getSceneManager()

SceneManager* Ogre::Page::getSceneManager | ( |  | ) | const

## ◆ handleRequest()

WorkQueue::Response* Ogre::Page::handleRequest | ( | const WorkQueue::Request * | req,
|  | const WorkQueue * | srcQ
| ) |  |
| virtual

WorkQueue::RequestHandler override.

Implements Ogre::WorkQueue::RequestHandler.

## ◆ handleResponse()

void Ogre::Page::handleResponse | ( | const WorkQueue::Response * | res,
|  | const WorkQueue * | srcQ
| ) |  |
| virtual

WorkQueue::ResponseHandler override.

Implements Ogre::WorkQueue::ResponseHandler.

## ◆ isDeferredProcessInProgress()

bool Ogre::Page::isDeferredProcessInProgress | ( |  | ) | const
| inline

If true, it's not safe to access this Page at this time, contents may be changing.

## ◆ isHeld()

virtual bool Ogre::Page::isHeld | ( |  | ) | const
| virtual

Returns whether this page was 'held' in the last frame, that is was it either directly needed, or requested to stay in memory (held - as in a buffer region for example).

If not, this page is eligible for removal.

## ◆ isModified()

bool Ogre::Page::isModified | ( |  | ) | const
| inline

## ◆ load()

virtual void Ogre::Page::load | ( | bool | synchronous | ) |
| virtual

Load this page.

Parameters

  synchronous | Whether to force this to happen synchronously.

## ◆ notifyCamera()

virtual void Ogre::Page::notifyCamera | ( | Camera * | cam | ) |
| virtual

Notify a section of the current camera.

## ◆ operator delete() [1/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete() [2/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator delete() [3/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |
| ) |  |
| inlineinherited

## ◆ operator delete[]() [1/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete[]() [2/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator new() [1/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new() [2/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

operator new, with debug line info

## ◆ operator new() [3/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr
| ) |  |
| inlineinherited

placement operator new

## ◆ operator new[]() [1/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new[]() [2/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

array operator new, with debug line info

## ◆ save() [1/3]

virtual void Ogre::Page::save | ( |  | ) |
| virtual

Save page data to an automatically generated file name.

## ◆ save() [2/3]

virtual void Ogre::Page::save | ( | const String & | filename | ) |
| virtual

Save page data to a file.

## ◆ save() [3/3]

virtual void Ogre::Page::save | ( | StreamSerialiser & | stream | ) |
| virtual

Save page data to a serialiser.

## ◆ touch()

virtual void Ogre::Page::touch | ( |  | ) |
| virtual

'Touch' the page to let it know it's being used

## ◆ unload()

virtual void Ogre::Page::unload | ( |  | ) |
| virtual

Unload this page.

## Friends And Related Function Documentation

## ◆ operator<<

_OgrePagingExport friend std::ostream& operator<< | ( | std::ostream & | o,
|  | const Page & | p
| ) |  |
| friend

Function for writing to a stream.

## Member Data Documentation

## ◆ CHUNK_CONTENTCOLLECTION_DECLARATION_ID

const uint32 Ogre::Page::CHUNK_CONTENTCOLLECTION_DECLARATION_ID
| static

## ◆ CHUNK_ID

const uint32 Ogre::Page::CHUNK_ID
| static

## ◆ CHUNK_VERSION

const uint16 Ogre::Page::CHUNK_VERSION
| static

## ◆ WORKQUEUE_CHANGECOLLECTION_REQUEST

const uint16 Ogre::Page::WORKQUEUE_CHANGECOLLECTION_REQUEST
| static

## ◆ WORKQUEUE_PREPARE_REQUEST

const uint16 Ogre::Page::WORKQUEUE_PREPARE_REQUEST
| static

The documentation for this class was generated from the following file:

- OgrePage.h